﻿using DataTableWCFService;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Runtime.InteropServices;
using System.ServiceModel;
using System.Text;
using System.Threading.Tasks;
using System.Timers;

namespace DataTableWCFClient
{
    internal class Program
    {
        static Timer _mainTimer;
        static IDataTableService _proxy;

        static void Main(string[] args)
        {
            Uri baseAddress = new Uri("http://10.233.101.136:9207/DataTableService");
            EndpointAddress endpointAddress = new EndpointAddress(baseAddress);

            BasicHttpBinding binding = new BasicHttpBinding();
            ChannelFactory<IDataTableService> factory = new ChannelFactory<IDataTableService>(binding, endpointAddress);
            _proxy = factory.CreateChannel();

            _mainTimer = new Timer();
            _mainTimer.Interval = 5000;
            _mainTimer.Elapsed += _mainTimer_Elapsed;
            _mainTimer.Start();

            Console.WriteLine("Press <Enter> to exit.");
            Console.ReadLine();

            _mainTimer.Elapsed -= _mainTimer_Elapsed;
            _mainTimer.Stop();

            ((IClientChannel)_proxy).Close();
        }

        private static void _mainTimer_Elapsed(object sender, ElapsedEventArgs e)
        {
            DataTable dataTable = _proxy.GetDataTable();
            foreach (DataRow row in dataTable.Rows)
            {
                Console.WriteLine($"ID: {row["ID"]}, Name: {row["Name"]}");
            }

            Random rand = new Random();
            int id = rand.Next(1000, 5001);
            _proxy.UpdateDataTable(id, $"New user {id.ToString("####")}");
        }
    }
}
